SoMaterial(3)

NAME
SoMaterial - The SoMaterial class is a node type for setting up material values for scene geometry.

SYNOPSIS

#include <Inventor/nodes/SoMaterial.h>

Inherits SoNode.

  Public Member Functions
virtual SoType getTypeId (void) const
SoMaterial (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual SbBool affectsState (void) const
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void pick (SoPickAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void search (SoSearchAction *action)
virtual void write (SoWriteAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
SbUniqueId getNodeId (void) const
virtual SoChildList * getChildren (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual void copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoMFColor ambientColor
SoMFColor diffuseColor
SoMFColor specularColor
SoMFColor emissiveColor
SoMFFloat shininess
SoMFFloat transparency

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoMaterial ()
virtual void notify (SoNotList *list)
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const
virtual SoNotRec createNotRec (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoMaterial class is a node type for setting up material values for scene geometry. After traversing an SoMaterial node, subsequent shape nodes with geometry in the scene graph will use values from the material "pool" of the traversal state set up from nodes of this type.

For detailed information on the various components, see the OpenGL color model, presented in the chapter "Colors and Coloring" (chapter 2.13 in the OpenGL 1.4 specification).

Note that values from a material node will replace the previous values from the traversal state, they will not accumulate. That's the case even when e.g. material changes are implicit in an iv-file, as illustrated by the following example:

Also note that support for multiple values in ambientColor, emissiveColor, specularColor and shininess was obsoleted in Open Inventor 2.1. The reason for this design change was performance driven, since it is relatively slow to change the OpenGL material properties. Changing the diffuse color value is fast though, so it is still possible to have multiple diffuseColor and transparency values.

#Inventor V2.1 ascii
Material { ambientColor 1 0 0 }
Cone { }
Translation { translation 5 0 0 }
Material { }
Sphere { }

(The SoSphere will not "inherit" the SoMaterial::ambientColor from the first SoMaterial node, even though it is not explicitly set in the second material node. The default value of SoMaterial::ambientColor will be used.)

Note that nodes imported as part of a VRML V1.0 file has a special case, where the fields SoMaterial::ambientColor, SoMaterial::diffuseColor and SoMaterial::specularColor contains zero values, and SoMaterial::emissiveColor contains one or more values. The values in SoMaterial::emissiveColor should then be treated as precalculated lighting, and the other fields should be ignored.

You can detect this case by checking the values of the material elements when the scene graph is traversed using an SoCallbackAction. SoDiffuseColorElement, SoAmbientColorElement, and SoSpecularColorElement will contain one value with a completely black color (0.0f, 0.0f, 0.0f), SoShininessElement will contain one value of 0.0f, and SoEmissiveColorElement will contain one or more values. It is done like this to make rendering work correctly on systems that do not test for this specific case.

You should only check for this case when you're traversing a VRML V1.0 file scene graph, of course. See SoNode::getNodeType() for information about how nodes can be tested for whether or not they have been imported or otherwise set up as of VRML1 type versus Inventor type.

When the scene graph is rendered using an SoGLRenderAction, the elements will be set differently to optimize rendering. The SoDiffuseColorElement will be set to the values in SoMaterial::emissiveColor, and the light model will be set to SoLightModel::BASE_COLOR.

The SoMaterial::transparency values will always be treated normally.

Here is a very simple usage example:

#Inventor V2.1 ascii
Separator {
   Coordinate3 {
      point [ 0 0 0, 1 0 0, 1 1 0 ]
   }
   Material {
      diffuseColor [ 1 0 0, 1 1 0, 0 0 1 ]
   }
   MaterialBinding {
      value PER_VERTEX
   }
   IndexedFaceSet {
      coordIndex [ 0, 1, 2, -1 ]
   }
}

FILE FORMAT/DEFAULTS:

Material {
    ambientColor 0.2 0.2 0.2
    diffuseColor 0.8 0.8 0.8
    specularColor 0 0 0
    emissiveColor 0 0 0
    shininess 0.2
    transparency 0
}

See also
    SoMaterialBinding, SoBaseColor, SoPackedColor

Constructor & Destructor Documentation

  SoMaterial::SoMaterial (void )
Constructor.

  SoMaterial::~SoMaterial () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoMaterial::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoMaterial::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

  const SoFieldData ** SoMaterial::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoMaterial::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoMaterial::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoMaterial::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoMaterial::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoMaterial::notify (SoNotList * l) [protected], [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Member Data Documentation

  SoMFColor SoMaterial::ambientColor
Ambient material part color values. Will by default contain a single color value of [0.2, 0.2, 0.2] (i.e. dark gray).

The ambient part of the material is not influenced by any light sources, and should be thought of conceptually as the constant, but small contribution of light to a scene "seeping in" from everywhere.

(Think of the ambient contribution in the context that there's always photons fizzing around everywhere -- even in a black room without light sources, for instance).

Only the first value in this field will be used. All other values will be ignored.

See also
    SoEnvironment::ambientIntensity

  SoMFColor SoMaterial::diffuseColor
Diffuse material part color values. This field is by default initialized to contain a single color value of [0.8, 0.8, 0.8] (light gray).

The diffuse part is combined with the light emitted from the scene's light sources.

Traditional Open Inventor uses the same override bit for both diffuse color and transparency. To get around this problem if you need to override one without the other, set the environment variable "COIN_SEPARATE_DIFFUSE_TRANSPARENCY_OVERRIDE". This is a Coin extension, and will not work on other Open Inventor implementations.

  SoMFColor SoMaterial::specularColor
Specular material part color values. Defaults to a single color value of [0, 0, 0] (black).

Only the first value in this field will be used. All other values will be ignored.

  SoMFColor SoMaterial::emissiveColor
The color of the light "emitted" by the subsequent geometry, independent of lighting / shading.

Defaults to contain a single color value of [0, 0, 0] (black, i.e. no contribution).

Only the first value in this field will be used. All other values will be ignored.

  SoMFFloat SoMaterial::shininess
Shininess values. Decides how the light from light sources are distributed across the geometry surfaces. Valid range is from 0.0 (which gives a dim appearance), to 1.0 (glossy-looking surfaces).

Defaults to contain a single value of 0.2.

Only the first value in this field will be used. All other values will be ignored.

  SoMFFloat SoMaterial::transparency
Transparency values. Valid range is from 0.0 (completely opaque, which is the default) to 1.0 (completely transparent, i.e. invisible).

Defaults to contain a single value of 0.0.

Traditional Open Inventor uses the same override bit for both transparency and diffuse color. To get around this problem if you need to override one without the other, set the environment variable "COIN_SEPARATE_DIFFUSE_TRANSPARENCY_OVERRIDE". This is a Coin extension, and will not work on other Open Inventor implementations.

Author

Generated automatically by Doxygen for Coin from the source code.